# Patch segment

PATCH https://app.launchdarkly.com/api/v2/segments/{projectKey}/{environmentKey}/{segmentKey}
Content-Type: application/json

Update a segment. The request body must be a valid semantic patch, JSON patch, or JSON merge patch. To learn more the different formats, read [Updates](https://launchdarkly.com/docs/api#updates).

### Using semantic patches on a segment

To make a semantic patch request, you must append `domain-model=launchdarkly.semanticpatch` to your `Content-Type` header. To learn more, read [Updates using semantic patch](https://launchdarkly.com/docs/api#updates-using-semantic-patch).

The body of a semantic patch request for updating segments requires an `environmentKey` in addition to `instructions` and an optional `comment`. The body of the request takes the following properties:

* `comment` (string): (Optional) A description of the update.
* `environmentKey` (string): (Required) The key of the LaunchDarkly environment.
* `instructions` (array): (Required) A list of actions the update should perform. Each action in the list must be an object with a `kind` property that indicates the instruction. If the action requires parameters, you must include those parameters as additional fields in the object.

### Instructions

Semantic patch requests support the following `kind` instructions for updating segments.

<details>
<summary>Click to expand instructions for <strong>updating segment details and settings</strong></summary>

#### addTags

Adds tags to the segment.

##### Parameters

- `values`: A list of tags to add.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addTags",
    "values": ["tag1", "tag2"]
  }]
}
```

#### removeTags

Removes tags from the segment.

##### Parameters

- `values`: A list of tags to remove.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeTags",
    "values": ["tag1", "tag2"]
  }]
}
```

#### updateName

Updates the name of the segment.

##### Parameters

- `value`: Name of the segment.

Here's an example:

```json
{
  "instructions": [{
    "kind": "updateName",
    "value": "Updated segment name"
  }]
}
```

</details>

<details>
<summary>Click to expand instructions for <strong>updating segment individual targets</strong></summary>

#### addExcludedTargets

Adds context keys to the individual context targets excluded from the segment for the specified `contextKind`. Returns an error if this causes the same context key to be both included and excluded, or if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `contextKind`: The context kind the targets should be added to.
- `values`: List of keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addExcludedTargets",
    "contextKind": "org",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### addExcludedUsers

Adds user keys to the individual user targets excluded from the segment. Returns an error if this causes the same user key to be both included and excluded, or if the number of operations on targets exceeds the batch limit of 1,500. If you are working with contexts, use `addExcludedTargets` instead of this instruction.

##### Parameters

- `values`: List of user keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addExcludedUsers",
    "values": [ "user-key-123abc", "user-key-456def" ]
  }]
}
```

#### addIncludedTargets

Adds context keys to the individual context targets included in the segment for the specified `contextKind`. Returns an error if this causes the same context key to be both included and excluded, or if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `contextKind`: The context kind the targets should be added to.
- `values`: List of keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addIncludedTargets",
    "contextKind": "org",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### addIncludedUsers

Adds user keys to the individual user targets included in the segment. Returns an error if this causes the same user key to be both included and excluded, or if the number of operations on targets exceeds the batch limit of 1,500. If you are working with contexts, use `addIncludedTargets` instead of this instruction.

##### Parameters

- `values`: List of user keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addIncludedUsers",
    "values": [ "user-key-123abc", "user-key-456def" ]
  }]
}
```

#### removeExcludedTargets

Removes context keys from the individual context targets excluded from the segment for the specified `contextKind`. Returns an error if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `contextKind`: The context kind the targets should be removed from.
- `values`: List of keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeExcludedTargets",
    "contextKind": "org",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### removeExcludedUsers

Removes user keys from the individual user targets excluded from the segment. If you are working with contexts, use `removeExcludedTargets` instead of this instruction. Returns an error if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `values`: List of user keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeExcludedUsers",
    "values": [ "user-key-123abc", "user-key-456def" ]
  }]
}
```

#### removeIncludedTargets

Removes context keys from the individual context targets included in the segment for the specified `contextKind`. Returns an error if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `contextKind`: The context kind the targets should be removed from.
- `values`: List of keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeIncludedTargets",
    "contextKind": "org",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### removeIncludedUsers

Removes user keys from the individual user targets included in the segment. If you are working with contexts, use `removeIncludedTargets` instead of this instruction. Returns an error if the number of operations on targets exceeds the batch limit of 1,500.

##### Parameters

- `values`: List of user keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeIncludedUsers",
    "values": [ "user-key-123abc", "user-key-456def" ]
  }]
}
```

</details>

<details>
<summary>Click to expand instructions for <strong>updating segment targeting rules</strong></summary>

#### addClauses

Adds the given clauses to the rule indicated by `ruleId`.

##### Parameters

- `clauses`: Array of clause objects, with `contextKind` (string), `attribute` (string), `op` (string), `negate` (boolean), and `values` (array of strings, numbers, or dates) properties. The `contextKind`, if not provided, defaults to `user`. The `contextKind`, `attribute`, and `values` are case sensitive. The `op` must be lower-case.
- `ruleId`: ID of a rule in the segment.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addClauses",
    "clauses": [
      {
        "attribute": "email",
        "negate": false,
        "op": "contains",
        "values": ["value1"]
      }
    ],
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
  }]
}
```

#### addRule

Adds a new targeting rule to the segment. The rule may contain `clauses`.

##### Parameters

- `clauses`: Array of clause objects, with `contextKind` (string), `attribute` (string), `op` (string), `negate` (boolean), and `values` (array of strings, numbers, or dates) properties. The `contextKind`, if not provided, defaults to `user`. The `contextKind`, `attribute`, and `values` are case sensitive. The `op` must be lower-case.
- `description`: A description of the rule.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addRule",
    "clauses": [
      {
        "attribute": "email",
        "op": "contains",
        "negate": false,
        "values": ["@launchdarkly.com"]
      }
    ],
    "description": "Targeting rule for LaunchDarkly employees",
  }]
}
```

#### addValuesToClause

Adds `values` to the values of the clause that `ruleId` and `clauseId` indicate. Does not update the context kind, attribute, or operator.

##### Parameters

- `ruleId`: ID of a rule in the segment.
- `clauseId`: ID of a clause in that rule.
- `values`: Array of strings, case sensitive.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addValuesToClause",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
    "clauseId": "10a58772-3121-400f-846b-b8a04e8944ed",
    "values": ["beta_testers"]
  }]
}
```

#### removeClauses

Removes the clauses specified by `clauseIds` from the rule indicated by `ruleId`.

##### Parameters

- `ruleId`: ID of a rule in the segment.
- `clauseIds`: Array of IDs of clauses in the rule.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeClauses",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
    "clauseIds": ["10a58772-3121-400f-846b-b8a04e8944ed", "36a461dc-235e-4b08-97b9-73ce9365873e"]
  }]
}
```

#### removeRule

Removes the targeting rule specified by `ruleId`. Does nothing if the rule does not exist.

##### Parameters

- `ruleId`: ID of a rule in the segment.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeRule",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
  }]
}
```

#### removeValuesFromClause

Removes `values` from the values of the clause indicated by `ruleId` and `clauseId`. Does not update the context kind, attribute, or operator.

##### Parameters

- `ruleId`: ID of a rule in the segment.
- `clauseId`: ID of a clause in that rule.
- `values`: Array of strings, case sensitive.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeValuesFromClause",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
    "clauseId": "10a58772-3121-400f-846b-b8a04e8944ed",
    "values": ["beta_testers"]
  }]
}
```

#### reorderRules

Rearranges the rules to match the order given in `ruleIds`. Returns an error if `ruleIds` does not match the current set of rules in the segment.

##### Parameters

- `ruleIds`: Array of IDs of all targeting rules in the segment.

Here's an example:

```json
{
  "instructions": [{
    "kind": "reorderRules",
    "ruleIds": ["a902ef4a-2faf-4eaf-88e1-ecc356708a29", "63c238d1-835d-435e-8f21-c8d5e40b2a3d"]
  }]
}
```

#### updateClause

Replaces the clause indicated by `ruleId` and `clauseId` with `clause`.

##### Parameters

- `ruleId`: ID of a rule in the segment.
- `clauseId`: ID of a clause in that rule.
- `clause`: New `clause` object, with `contextKind` (string), `attribute` (string), `op` (string), `negate` (boolean), and `values` (array of strings, numbers, or dates) properties. The `contextKind`, if not provided, defaults to `user`. The `contextKind`, `attribute`, and `values` are case sensitive. The `op` must be lower-case.

Here's an example:

```json
{
  "instructions": [{
    "kind": "updateClause",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
    "clauseId": "10c7462a-2062-45ba-a8bb-dfb3de0f8af5",
    "clause": {
      "contextKind": "user",
      "attribute": "country",
      "op": "in",
      "negate": false,
      "values": ["Mexico", "Canada"]
    }
  }]
}
```

#### updateRuleDescription

Updates the description of the segment targeting rule.

##### Parameters

- `description`: The new human-readable description for this rule.
- `ruleId`: The ID of the rule. You can retrieve this by making a GET request for the segment.

Here's an example:

```json
{
  "instructions": [{
    "kind": "updateRuleDescription",
    "description": "New rule description",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
  }]
}
```

#### updateRuleRolloutAndContextKind

For a rule that includes a percentage of targets, updates the percentage and the context kind of the targets to include.

##### Parameters

- `ruleId`: The ID of a targeting rule in the segment that includes a percentage of targets.
- `weight`: The weight, in thousandths of a percent (0-100000).
- `contextKind`: The context kind.

Here's an example:

```json
{
  "instructions": [{
    "kind": "reorderRules",
    "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
    "weight": "20000",
    "contextKind": "device"
  }]
}
```

</details>

<details>
<summary>Click to expand instructions for <strong>working with Big Segments</strong></summary>

A "big segment" is a segment that is either a synced segment, or a list-based segment with more than 15,000 entries that includes only one targeted context kind. LaunchDarkly uses different implementations for different types of segments so that all of your segments have good performance.

The following semantic patch instructions apply only to these [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments).

#### addBigSegmentExcludedTargets

For use with [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments) ONLY. Adds context keys to the context targets excluded from the segment. Returns an error if this causes the same context key to be both included and excluded.

##### Parameters

- `values`: List of context keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addBigSegmentExcludedTargets",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### addBigSegmentIncludedTargets

For use with [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments) ONLY. Adds context keys to the context targets included in the segment. Returns an error if this causes the same context key to be both included and excluded.

##### Parameters

- `values`: List of context keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "addBigSegmentIncludedTargets",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### processBigSegmentImport

For use with [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments) ONLY. Processes a segment import.

##### Parameters

- `importId`: The ID of the import. The import ID is returned in the `Location` header as part of the [Create big segment import](https://launchdarkly.com/docs/api/segments/create-big-segment-import) request.

Here's an example:

```json
{
  "instructions": [{
    "kind": "processBigSegmentImport",
    "importId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
  }]
}
```


#### removeBigSegmentExcludedTargets

For use with [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments) ONLY. Removes context keys from the context targets excluded from the segment.

##### Parameters

- `values`: List of context keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeBigSegmentExcludedTargets",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

#### removeBigSegmentIncludedTargets

For use with [larger list-based segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments) ONLY. Removes context keys from the context targets included in the segment.

##### Parameters

- `values`: List of context keys.

Here's an example:

```json
{
  "instructions": [{
    "kind": "removeBigSegmentIncludedTargets",
    "values": [ "org-key-123abc", "org-key-456def" ]
  }]
}
```

</details>

### Using JSON patches on a segment

If you do not include the header described above, you can use a [JSON patch](https://launchdarkly.com/docs/api#updates-using-json-patch) or [JSON merge patch](https://datatracker.ietf.org/doc/html/rfc7386) representation of the desired changes.

For example, to update the description for a segment with a JSON patch, use the following request body:

```json
{
  "patch": [
    {
      "op": "replace",
      "path": "/description",
      "value": "new description"
    }
  ]
}
```

To update fields in the segment that are arrays, set the `path` to the name of the field and then append `/<array index>`. Use `/0` to add the new entry to the beginning of the array. Use `/-` to add the new entry to the end of the array.

For example, to add a rule to a segment, use the following request body:

```json
{
  "patch":[
    {
      "op": "add",
      "path": "/rules/0",
      "value": {
        "clauses": [{ "contextKind": "user", "attribute": "email", "op": "endsWith", "values": [".edu"], "negate": false }]
      }
    }
  ]
}
```

To add or remove targets from segments, we recommend using semantic patch. Semantic patch for segments includes specific instructions for adding and removing both included and excluded targets.


Reference: https://launchdarkly.com/docs/api/segments/patch-segment

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/segments/{projectKey}/{environmentKey}/{segmentKey}:
    patch:
      operationId: patch-segment
      summary: Patch segment
      description: >
        Update a segment. The request body must be a valid semantic patch, JSON
        patch, or JSON merge patch. To learn more the different formats, read
        [Updates](https://launchdarkly.com/docs/api#updates).


        ### Using semantic patches on a segment


        To make a semantic patch request, you must append
        `domain-model=launchdarkly.semanticpatch` to your `Content-Type` header.
        To learn more, read [Updates using semantic
        patch](https://launchdarkly.com/docs/api#updates-using-semantic-patch).


        The body of a semantic patch request for updating segments requires an
        `environmentKey` in addition to `instructions` and an optional
        `comment`. The body of the request takes the following properties:


        * `comment` (string): (Optional) A description of the update.

        * `environmentKey` (string): (Required) The key of the LaunchDarkly
        environment.

        * `instructions` (array): (Required) A list of actions the update should
        perform. Each action in the list must be an object with a `kind`
        property that indicates the instruction. If the action requires
        parameters, you must include those parameters as additional fields in
        the object.


        ### Instructions


        Semantic patch requests support the following `kind` instructions for
        updating segments.


        <details>

        <summary>Click to expand instructions for <strong>updating segment
        details and settings</strong></summary>


        #### addTags


        Adds tags to the segment.


        ##### Parameters


        - `values`: A list of tags to add.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addTags",
            "values": ["tag1", "tag2"]
          }]
        }

        ```


        #### removeTags


        Removes tags from the segment.


        ##### Parameters


        - `values`: A list of tags to remove.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeTags",
            "values": ["tag1", "tag2"]
          }]
        }

        ```


        #### updateName


        Updates the name of the segment.


        ##### Parameters


        - `value`: Name of the segment.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "updateName",
            "value": "Updated segment name"
          }]
        }

        ```


        </details>


        <details>

        <summary>Click to expand instructions for <strong>updating segment
        individual targets</strong></summary>


        #### addExcludedTargets


        Adds context keys to the individual context targets excluded from the
        segment for the specified `contextKind`. Returns an error if this causes
        the same context key to be both included and excluded, or if the number
        of operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `contextKind`: The context kind the targets should be added to.

        - `values`: List of keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addExcludedTargets",
            "contextKind": "org",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### addExcludedUsers


        Adds user keys to the individual user targets excluded from the segment.
        Returns an error if this causes the same user key to be both included
        and excluded, or if the number of operations on targets exceeds the
        batch limit of 1,500. If you are working with contexts, use
        `addExcludedTargets` instead of this instruction.


        ##### Parameters


        - `values`: List of user keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addExcludedUsers",
            "values": [ "user-key-123abc", "user-key-456def" ]
          }]
        }

        ```


        #### addIncludedTargets


        Adds context keys to the individual context targets included in the
        segment for the specified `contextKind`. Returns an error if this causes
        the same context key to be both included and excluded, or if the number
        of operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `contextKind`: The context kind the targets should be added to.

        - `values`: List of keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addIncludedTargets",
            "contextKind": "org",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### addIncludedUsers


        Adds user keys to the individual user targets included in the segment.
        Returns an error if this causes the same user key to be both included
        and excluded, or if the number of operations on targets exceeds the
        batch limit of 1,500. If you are working with contexts, use
        `addIncludedTargets` instead of this instruction.


        ##### Parameters


        - `values`: List of user keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addIncludedUsers",
            "values": [ "user-key-123abc", "user-key-456def" ]
          }]
        }

        ```


        #### removeExcludedTargets


        Removes context keys from the individual context targets excluded from
        the segment for the specified `contextKind`. Returns an error if the
        number of operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `contextKind`: The context kind the targets should be removed from.

        - `values`: List of keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeExcludedTargets",
            "contextKind": "org",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### removeExcludedUsers


        Removes user keys from the individual user targets excluded from the
        segment. If you are working with contexts, use `removeExcludedTargets`
        instead of this instruction. Returns an error if the number of
        operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `values`: List of user keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeExcludedUsers",
            "values": [ "user-key-123abc", "user-key-456def" ]
          }]
        }

        ```


        #### removeIncludedTargets


        Removes context keys from the individual context targets included in the
        segment for the specified `contextKind`. Returns an error if the number
        of operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `contextKind`: The context kind the targets should be removed from.

        - `values`: List of keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeIncludedTargets",
            "contextKind": "org",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### removeIncludedUsers


        Removes user keys from the individual user targets included in the
        segment. If you are working with contexts, use `removeIncludedTargets`
        instead of this instruction. Returns an error if the number of
        operations on targets exceeds the batch limit of 1,500.


        ##### Parameters


        - `values`: List of user keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeIncludedUsers",
            "values": [ "user-key-123abc", "user-key-456def" ]
          }]
        }

        ```


        </details>


        <details>

        <summary>Click to expand instructions for <strong>updating segment
        targeting rules</strong></summary>


        #### addClauses


        Adds the given clauses to the rule indicated by `ruleId`.


        ##### Parameters


        - `clauses`: Array of clause objects, with `contextKind` (string),
        `attribute` (string), `op` (string), `negate` (boolean), and `values`
        (array of strings, numbers, or dates) properties. The `contextKind`, if
        not provided, defaults to `user`. The `contextKind`, `attribute`, and
        `values` are case sensitive. The `op` must be lower-case.

        - `ruleId`: ID of a rule in the segment.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addClauses",
            "clauses": [
              {
                "attribute": "email",
                "negate": false,
                "op": "contains",
                "values": ["value1"]
              }
            ],
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
          }]
        }

        ```


        #### addRule


        Adds a new targeting rule to the segment. The rule may contain
        `clauses`.


        ##### Parameters


        - `clauses`: Array of clause objects, with `contextKind` (string),
        `attribute` (string), `op` (string), `negate` (boolean), and `values`
        (array of strings, numbers, or dates) properties. The `contextKind`, if
        not provided, defaults to `user`. The `contextKind`, `attribute`, and
        `values` are case sensitive. The `op` must be lower-case.

        - `description`: A description of the rule.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addRule",
            "clauses": [
              {
                "attribute": "email",
                "op": "contains",
                "negate": false,
                "values": ["@launchdarkly.com"]
              }
            ],
            "description": "Targeting rule for LaunchDarkly employees",
          }]
        }

        ```


        #### addValuesToClause


        Adds `values` to the values of the clause that `ruleId` and `clauseId`
        indicate. Does not update the context kind, attribute, or operator.


        ##### Parameters


        - `ruleId`: ID of a rule in the segment.

        - `clauseId`: ID of a clause in that rule.

        - `values`: Array of strings, case sensitive.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addValuesToClause",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
            "clauseId": "10a58772-3121-400f-846b-b8a04e8944ed",
            "values": ["beta_testers"]
          }]
        }

        ```


        #### removeClauses


        Removes the clauses specified by `clauseIds` from the rule indicated by
        `ruleId`.


        ##### Parameters


        - `ruleId`: ID of a rule in the segment.

        - `clauseIds`: Array of IDs of clauses in the rule.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeClauses",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
            "clauseIds": ["10a58772-3121-400f-846b-b8a04e8944ed", "36a461dc-235e-4b08-97b9-73ce9365873e"]
          }]
        }

        ```


        #### removeRule


        Removes the targeting rule specified by `ruleId`. Does nothing if the
        rule does not exist.


        ##### Parameters


        - `ruleId`: ID of a rule in the segment.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeRule",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
          }]
        }

        ```


        #### removeValuesFromClause


        Removes `values` from the values of the clause indicated by `ruleId` and
        `clauseId`. Does not update the context kind, attribute, or operator.


        ##### Parameters


        - `ruleId`: ID of a rule in the segment.

        - `clauseId`: ID of a clause in that rule.

        - `values`: Array of strings, case sensitive.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeValuesFromClause",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
            "clauseId": "10a58772-3121-400f-846b-b8a04e8944ed",
            "values": ["beta_testers"]
          }]
        }

        ```


        #### reorderRules


        Rearranges the rules to match the order given in `ruleIds`. Returns an
        error if `ruleIds` does not match the current set of rules in the
        segment.


        ##### Parameters


        - `ruleIds`: Array of IDs of all targeting rules in the segment.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "reorderRules",
            "ruleIds": ["a902ef4a-2faf-4eaf-88e1-ecc356708a29", "63c238d1-835d-435e-8f21-c8d5e40b2a3d"]
          }]
        }

        ```


        #### updateClause


        Replaces the clause indicated by `ruleId` and `clauseId` with `clause`.


        ##### Parameters


        - `ruleId`: ID of a rule in the segment.

        - `clauseId`: ID of a clause in that rule.

        - `clause`: New `clause` object, with `contextKind` (string),
        `attribute` (string), `op` (string), `negate` (boolean), and `values`
        (array of strings, numbers, or dates) properties. The `contextKind`, if
        not provided, defaults to `user`. The `contextKind`, `attribute`, and
        `values` are case sensitive. The `op` must be lower-case.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "updateClause",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
            "clauseId": "10c7462a-2062-45ba-a8bb-dfb3de0f8af5",
            "clause": {
              "contextKind": "user",
              "attribute": "country",
              "op": "in",
              "negate": false,
              "values": ["Mexico", "Canada"]
            }
          }]
        }

        ```


        #### updateRuleDescription


        Updates the description of the segment targeting rule.


        ##### Parameters


        - `description`: The new human-readable description for this rule.

        - `ruleId`: The ID of the rule. You can retrieve this by making a GET
        request for the segment.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "updateRuleDescription",
            "description": "New rule description",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
          }]
        }

        ```


        #### updateRuleRolloutAndContextKind


        For a rule that includes a percentage of targets, updates the percentage
        and the context kind of the targets to include.


        ##### Parameters


        - `ruleId`: The ID of a targeting rule in the segment that includes a
        percentage of targets.

        - `weight`: The weight, in thousandths of a percent (0-100000).

        - `contextKind`: The context kind.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "reorderRules",
            "ruleId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29",
            "weight": "20000",
            "contextKind": "device"
          }]
        }

        ```


        </details>


        <details>

        <summary>Click to expand instructions for <strong>working with Big
        Segments</strong></summary>


        A "big segment" is a segment that is either a synced segment, or a
        list-based segment with more than 15,000 entries that includes only one
        targeted context kind. LaunchDarkly uses different implementations for
        different types of segments so that all of your segments have good
        performance.


        The following semantic patch instructions apply only to these [larger
        list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments).


        #### addBigSegmentExcludedTargets


        For use with [larger list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments)
        ONLY. Adds context keys to the context targets excluded from the
        segment. Returns an error if this causes the same context key to be both
        included and excluded.


        ##### Parameters


        - `values`: List of context keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addBigSegmentExcludedTargets",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### addBigSegmentIncludedTargets


        For use with [larger list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments)
        ONLY. Adds context keys to the context targets included in the segment.
        Returns an error if this causes the same context key to be both included
        and excluded.


        ##### Parameters


        - `values`: List of context keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "addBigSegmentIncludedTargets",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### processBigSegmentImport


        For use with [larger list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments)
        ONLY. Processes a segment import.


        ##### Parameters


        - `importId`: The ID of the import. The import ID is returned in the
        `Location` header as part of the [Create big segment
        import](https://launchdarkly.com/docs/api/segments/create-big-segment-import)
        request.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "processBigSegmentImport",
            "importId": "a902ef4a-2faf-4eaf-88e1-ecc356708a29"
          }]
        }

        ```



        #### removeBigSegmentExcludedTargets


        For use with [larger list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments)
        ONLY. Removes context keys from the context targets excluded from the
        segment.


        ##### Parameters


        - `values`: List of context keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeBigSegmentExcludedTargets",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        #### removeBigSegmentIncludedTargets


        For use with [larger list-based
        segments](https://launchdarkly.com/docs/home/flags/segments-create#create-larger-list-based-segments)
        ONLY. Removes context keys from the context targets included in the
        segment.


        ##### Parameters


        - `values`: List of context keys.


        Here's an example:


        ```json

        {
          "instructions": [{
            "kind": "removeBigSegmentIncludedTargets",
            "values": [ "org-key-123abc", "org-key-456def" ]
          }]
        }

        ```


        </details>


        ### Using JSON patches on a segment


        If you do not include the header described above, you can use a [JSON
        patch](https://launchdarkly.com/docs/api#updates-using-json-patch) or
        [JSON merge patch](https://datatracker.ietf.org/doc/html/rfc7386)
        representation of the desired changes.


        For example, to update the description for a segment with a JSON patch,
        use the following request body:


        ```json

        {
          "patch": [
            {
              "op": "replace",
              "path": "/description",
              "value": "new description"
            }
          ]
        }

        ```


        To update fields in the segment that are arrays, set the `path` to the
        name of the field and then append `/<array index>`. Use `/0` to add the
        new entry to the beginning of the array. Use `/-` to add the new entry
        to the end of the array.


        For example, to add a rule to a segment, use the following request body:


        ```json

        {
          "patch":[
            {
              "op": "add",
              "path": "/rules/0",
              "value": {
                "clauses": [{ "contextKind": "user", "attribute": "email", "op": "endsWith", "values": [".edu"], "negate": false }]
              }
            }
          ]
        }

        ```


        To add or remove targets from segments, we recommend using semantic
        patch. Semantic patch for segments includes specific instructions for
        adding and removing both included and excluded targets.
      tags:
        - subpackage_segments
      parameters:
        - name: projectKey
          in: path
          description: The project key
          required: true
          schema:
            type: string
            format: string
        - name: environmentKey
          in: path
          description: The environment key
          required: true
          schema:
            type: string
            format: string
        - name: segmentKey
          in: path
          description: The segment key
          required: true
          schema:
            type: string
            format: string
        - name: dryRun
          in: query
          description: >-
            If true, the patch will be validated but not persisted. Returns a
            preview of the segment after the patch is applied.
          required: false
          schema:
            type: boolean
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Segment response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UserSegment'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorRep'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorRep'
        '404':
          description: Invalid resource identifier
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorRep'
        '409':
          description: Status conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StatusConflictErrorRep'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedErrorRep'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchWithComment'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    PatchOperation:
      type: object
      properties:
        op:
          type: string
          description: The type of operation to perform
        path:
          type: string
          description: >-
            A JSON Pointer string specifying the part of the document to operate
            on
        value:
          description: A JSON value used in "add", "replace", and "test" operations
      required:
        - op
        - path
      title: PatchOperation
    JSONPatch:
      type: array
      items:
        $ref: '#/components/schemas/PatchOperation'
      title: JSONPatch
    PatchWithComment:
      type: object
      properties:
        patch:
          $ref: '#/components/schemas/JSONPatch'
          description: A JSON patch representation of the change to make
        comment:
          type: string
          description: Optional comment
      required:
        - patch
      title: PatchWithComment
    UnixMillis:
      type: integer
      format: int64
      title: UnixMillis
    SegmentTarget:
      type: object
      properties:
        values:
          type: array
          items:
            type: string
        contextKind:
          type: string
      title: SegmentTarget
    Link:
      type: object
      properties:
        href:
          type: string
          description: The URL of the link
        type:
          type: string
          description: The type of the link
      title: Link
    Operator:
      type: string
      title: Operator
    Clause:
      type: object
      properties:
        _id:
          type: string
        attribute:
          type: string
        op:
          $ref: '#/components/schemas/Operator'
        values:
          type: array
          items:
            description: Any type
        contextKind:
          type: string
        negate:
          type: boolean
      required:
        - attribute
        - op
        - values
        - negate
      title: Clause
    UserSegmentRule:
      type: object
      properties:
        _id:
          type: string
        clauses:
          type: array
          items:
            $ref: '#/components/schemas/Clause'
        weight:
          type: integer
        rolloutContextKind:
          type: string
        bucketBy:
          type: string
        description:
          type: string
      required:
        - clauses
      title: UserSegmentRule
    ActionIdentifier:
      type: string
      title: ActionIdentifier
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    AccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessDeniedReasonEffect
    AccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessDeniedReason
    AccessDenied:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessDeniedReason'
      required:
        - action
        - reason
      title: AccessDenied
    AccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessAllowedReasonEffect
    AccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessAllowedReason
    AccessAllowedRep:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessAllowedReason'
      required:
        - action
        - reason
      title: AccessAllowedRep
    Access:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AccessAllowedRep'
      required:
        - denied
        - allowed
      title: Access
    FlagListingRep:
      type: object
      properties:
        name:
          type: string
          description: The flag name
        key:
          type: string
          description: The flag key
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/Link'
        _site:
          $ref: '#/components/schemas/Link'
      required:
        - name
        - key
      title: FlagListingRep
    SegmentId:
      type: string
      title: SegmentId
    SegmentMetadata:
      type: object
      properties:
        envId:
          type: string
        segmentId:
          $ref: '#/components/schemas/SegmentId'
        version:
          type: integer
        includedCount:
          type: integer
        excludedCount:
          type: integer
        lastModified:
          $ref: '#/components/schemas/UnixMillis'
        deleted:
          type: boolean
      title: SegmentMetadata
    UserSegment:
      type: object
      properties:
        name:
          type: string
          description: A human-friendly name for the segment.
        description:
          type: string
          description: >-
            A description of the segment's purpose. Defaults to
            <code>null</code> and is omitted in the response if not provided.
        tags:
          type: array
          items:
            type: string
          description: Tags for the segment. Defaults to an empty array.
        creationDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp of when the segment was created
        lastModifiedDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp of when the segment was last modified
        key:
          type: string
          description: A unique key used to reference the segment
        included:
          type: array
          items:
            type: string
          description: >-
            An array of keys for included targets. Included individual targets
            are always segment members, regardless of segment rules. For
            list-based segments over 15,000 entries, also called big segments,
            this array is either empty or omitted.
        excluded:
          type: array
          items:
            type: string
          description: >-
            An array of keys for excluded targets. Segment rules bypass
            individual excluded targets, so they will never be included based on
            rules. Excluded targets may still be included explicitly. This value
            is omitted for list-based segments over 15,000 entries, also called
            big segments.
        includedContexts:
          type: array
          items:
            $ref: '#/components/schemas/SegmentTarget'
        excludedContexts:
          type: array
          items:
            $ref: '#/components/schemas/SegmentTarget'
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/Link'
          description: The location and content type of related resources
        rules:
          type: array
          items:
            $ref: '#/components/schemas/UserSegmentRule'
          description: An array of the targeting rules for this segment.
        version:
          type: integer
          description: Version of the segment
        deleted:
          type: boolean
          description: Whether the segment has been deleted
        _access:
          $ref: '#/components/schemas/Access'
        _flags:
          type: array
          items:
            $ref: '#/components/schemas/FlagListingRep'
          description: >-
            A list of flags targeting this segment. Only included when getting a
            single segment, using the <code>getSegment</code> endpoint.
        unbounded:
          type: boolean
          description: >-
            Whether this is a standard segment (<code>false</code>) or a big
            segment (<code>true</code>). Standard segments include rule-based
            segments and smaller list-based segments. Big segments include
            larger list-based segments and synced segments. If omitted, the
            segment is a standard segment.
        unboundedContextKind:
          type: string
          description: For big segments, the targeted context kind.
        generation:
          type: integer
          description: For big segments, how many times this segment has been created.
        _unboundedMetadata:
          $ref: '#/components/schemas/SegmentMetadata'
          description: >-
            Details on the external data store backing this segment. Only
            applies to big segments.
        _external:
          type: string
          description: >-
            The external data store backing this segment. Only applies to synced
            segments.
        _externalLink:
          type: string
          description: >-
            The URL for the external data store backing this segment. Only
            applies to synced segments.
        _importInProgress:
          type: boolean
          description: >-
            Whether an import is currently in progress for the specified
            segment. Only applies to big segments.
      required:
        - name
        - tags
        - creationDate
        - lastModifiedDate
        - key
        - _links
        - rules
        - version
        - deleted
        - generation
      title: UserSegment
    InvalidRequestErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: InvalidRequestErrorRep
    UnauthorizedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: UnauthorizedErrorRep
    ForbiddenErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: ForbiddenErrorRep
    NotFoundErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: NotFoundErrorRep
    StatusConflictErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: StatusConflictErrorRep
    RateLimitedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: RateLimitedErrorRep
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey"

payload = { "patch": [
        {
            "op": "replace",
            "path": "/description"
        },
        {
            "op": "add",
            "path": "/tags/0"
        }
    ] }
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey';
const options = {
  method: 'PATCH',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"patch":[{"op":"replace","path":"/description"},{"op":"add","path":"/tags/0"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey"

	payload := strings.NewReader("{\n  \"patch\": [\n    {\n      \"op\": \"replace\",\n      \"path\": \"/description\"\n    },\n    {\n      \"op\": \"add\",\n      \"path\": \"/tags/0\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"patch\": [\n    {\n      \"op\": \"replace\",\n      \"path\": \"/description\"\n    },\n    {\n      \"op\": \"add\",\n      \"path\": \"/tags/0\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"patch\": [\n    {\n      \"op\": \"replace\",\n      \"path\": \"/description\"\n    },\n    {\n      \"op\": \"add\",\n      \"path\": \"/tags/0\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey', [
  'body' => '{
  "patch": [
    {
      "op": "replace",
      "path": "/description"
    },
    {
      "op": "add",
      "path": "/tags/0"
    }
  ]
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"patch\": [\n    {\n      \"op\": \"replace\",\n      \"path\": \"/description\"\n    },\n    {\n      \"op\": \"add\",\n      \"path\": \"/tags/0\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["patch": [
    [
      "op": "replace",
      "path": "/description"
    ],
    [
      "op": "add",
      "path": "/tags/0"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/segments/projectKey/environmentKey/segmentKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```